package com.smartgwt.mobile.client.internal;

import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.data.Record;

@SGWTInternal
public final class Array {

    public static final Record LOADING = new Record();
    static {
        LOADING.put("__loading__", "LOADING...");
    }

    public static boolean is(Object obj) {
        return (obj instanceof Object[] ||
                obj instanceof char[] ||
                obj instanceof byte[] ||
                obj instanceof short[] ||
                obj instanceof int[] ||
                obj instanceof long[] ||
                obj instanceof float[] ||
                obj instanceof double[] ||
                obj instanceof boolean[]);
    }

    /**
     * An implementation of {@link java.lang.reflect.Array#getLength(Object)} for GWT.
     */
    public static int arrayLength(Object array) {
        if (array instanceof Object[]) return ((Object[])array).length;
        else if (array instanceof char[]) return ((char[])array).length;
        else if (array instanceof byte[]) return ((byte[])array).length;
        else if (array instanceof short[]) return ((short[])array).length;
        else if (array instanceof int[]) return ((int[])array).length;
        else if (array instanceof long[]) return ((long[])array).length;
        else if (array instanceof float[]) return ((float[])array).length;
        else if (array instanceof double[]) return ((double[])array).length;
        else return ((boolean[])array).length;
    }

    /**
     * An implementation of {@link java.lang.reflect.Array#get(Object, int)} for GWT.
     */
    public static Object arrayGet(Object array, int i) {
        if (array instanceof Object[]) return ((Object[])array)[i];
        else if (array instanceof char[]) return ((char[])array)[i];
        else if (array instanceof byte[]) return ((byte[])array)[i];
        else if (array instanceof short[]) return ((short[])array)[i];
        else if (array instanceof int[]) return ((int[])array)[i];
        else if (array instanceof long[]) return ((long[])array)[i];
        else if (array instanceof float[]) return ((float[])array)[i];
        else if (array instanceof double[]) return ((double[])array)[i];
        else return ((boolean[])array)[i];
    }

    private Array() {}
}
