package com.smartgwt.mobile.client.internal;

import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.EventTarget;
import com.google.gwt.dom.client.NativeEvent;
import com.google.gwt.dom.client.Node;
import com.smartgwt.mobile.SGWTInternal;

@SGWTInternal
public final class EventUtil {

    // Mobile Safari for iOS 4.3.2 devices and possibly other browsers can use a Text node for the target
    // of an event.
    public static Element getElement(EventTarget target) {
        if (Element.is(target)) {
            return Element.as(target);
        } else if (Node.is(target)) {
            final Node n = Node.as(target);
            return n.getParentElement();
        }
        return null;
    }

    public static Element getRelatedElement(NativeEvent event) {
        return getElement(event.getRelatedEventTarget());
    }

    public static Element getTargetElem(NativeEvent event) {
        return getElement(event.getEventTarget());
    }

    private EventUtil() {}
}
