package com.smartgwt.mobile.client.internal.theme.iphone;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.DataResource;
import com.google.gwt.resources.client.ImageResource;
import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.theme.ThemeResources;

@SGWTInternal
public interface ThemeResourcesIPhone extends ThemeResources {

    @SGWTInternal
    public static final ThemeResourcesIPhone _INSTANCE = GWT.create(ThemeResourcesIPhone.class);

    // The left (right) border image was created with the following steps:
    // 1. Create a new 1x38 image in GIMP, transparent background.
    // 2. Select the Blend Tool. Use the built-in gradient "FG to Transparent". Set the foreground
    //    color to white (black).
    // 3. Fill from (0.5, 0) to (0.5, 50).

    @Source("menuitem_border-right.png")
    public DataResource menuItemBorderRightImageData();

    @Source("menuitem_border-left.png")
    public DataResource menuItemBorderLeftImageData();

    // The reason why the search item icon appears as a DataResource and ImageResource is so
    // that it may be used with @url references as well as value() calls.
    // https://groups.google.com/d/topic/google-web-toolkit/3120BA8fXHY/discussion
    @Source("searchitem_icon.png")
    public DataResource searchItemIconImageData();
    @Source("searchitem_icon.png")
    public ImageResource searchItemIconImage();
    @Source("searchitem_icon~2.png")
    public DataResource retinaSearchItemIconImageData();

    @Source("form.gwt.css")
    public FormCssResourceIPhone formCSS();

    @Source("menu.gwt.css")
    public MenuCssResourceIPhone menuCSS();
}
