package com.smartgwt.mobile.client.internal.widgets;

import com.google.gwt.dom.client.DivElement;
import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.StyleInjector;
import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.theme.ThemeResources;

@SGWTInternal
public class ActivityIndicatorImplBlades extends ActivityIndicatorImpl {

    static {
        StyleInjector.injectAtStart(ThemeResources.INSTANCE.activityIndicatorCSS().getText());
    }

    /**
     * The number of blades in the activity indicator. Not a public property for now as the number of blades
     * is currently fixed in the CSS definition.
     */
    private int numBlades = 8;
    private String bladeClassName = "sc-blade";

    public ActivityIndicatorImplBlades() {
        Element element = getElement();
        final Document document = Document.get();
        for (int i = 0; i < numBlades; i++) {
            DivElement bladeDiv = document.createDivElement();
            bladeDiv.setClassName(bladeClassName);
            element.appendChild(bladeDiv);
        }
    }
}
