package com.smartgwt.mobile.client.internal.widgets;

import com.google.gwt.core.client.GWT;
import com.smartgwt.mobile.SGWTInternal;

@SGWTInternal
public class CanvasStaticImpl {

    public static class IsHistoryEnabledImpl {
        public boolean isHistoryEnabled() {
            return false;
        }
    }

    public static class IsHistoryEnabledImplHistoryEnabled extends IsHistoryEnabledImpl {
        @Override
        public boolean isHistoryEnabled() {
            return true;
        }
    }

    public static class IsUIWebViewImpl {
        public boolean isUIWebView() {
            return false;
        }
    }

    public static class IsUIWebViewImplUIWebView extends IsUIWebViewImpl {
        @Override
        public boolean isUIWebView() {
            return true;
        }
    }

    public static class UseIOSNativeScrollingImpl {
        public boolean useIOSNativeScrolling() {
            return false;
        }
    }

    public static class UseIOSNativeScrollingImplUseNativeScrolling extends UseIOSNativeScrollingImpl {
        @Override
        public boolean useIOSNativeScrolling() {
            return true;
        }
    }

    private IsHistoryEnabledImpl isHistoryEnabledImpl = GWT.create(IsHistoryEnabledImpl.class);
    private IsUIWebViewImpl isUIWebViewImpl = GWT.create(IsUIWebViewImpl.class);
    private UseIOSNativeScrollingImpl useIOSNativeScrollingImpl = GWT.create(UseIOSNativeScrollingImpl.class);

    public final boolean isHistoryEnabled() {
        return isHistoryEnabledImpl.isHistoryEnabled();
    }

    public boolean isAndroid() {
        return false;
    }

    public boolean isIPad() {
        return false;
    }

    public boolean isIPhone() {
        return false;
    }

    public final boolean isUIWebView() {
        return isUIWebViewImpl.isUIWebView();
    }

    public final boolean useIOSNativeScrolling() {
        return useIOSNativeScrollingImpl.useIOSNativeScrolling();
    }
}
