package com.smartgwt.mobile.client.internal.widgets.events;

import com.google.gwt.event.shared.GwtEvent;
import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.widgets.Canvas;

@SGWTInternal
public class ContentChangedEvent extends GwtEvent<ContentChangedHandler> {

    private static Type<ContentChangedHandler> TYPE;

    public static Type<ContentChangedHandler> getType() {
        if (TYPE == null) {
            TYPE = new Type<ContentChangedHandler>();
        }
        return TYPE;
    }

    public static <S extends HasContentChangedHandlers> void fire(S source, Canvas canvas) {
        if (TYPE != null) {
            ContentChangedEvent event = new ContentChangedEvent(canvas);
            event.setSource(source);
            source.fireEvent(event);
        }
    }

    private Canvas canvas;

    private ContentChangedEvent(Canvas canvas) {
        this.canvas = canvas;
    }

    @Override
    public Type<ContentChangedHandler> getAssociatedType() {
        return TYPE;
    }

    @Override
    protected void dispatch(ContentChangedHandler handler) {
        handler._onContentChanged(this);
    }

    public final Canvas getCanvas() {
        return canvas;
    }
}
