/*
 * SmartGWT Mobile
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * SmartGWT Mobile is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  SmartGWT Mobile is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */

package com.smartgwt.mobile.client.internal.widgets.layout;

import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.widgets.Canvas;
import com.smartgwt.mobile.client.widgets.Header1;
import com.smartgwt.mobile.client.widgets.NavigationButton;
import com.smartgwt.mobile.client.widgets.layout.NavigationBar;

/**
 * This class encapsulates the various buttons and title information to be displayed for a given {@link NavigationBar}.
 */
@SGWTInternal
public class NavigationItem {

    private NavigationButton leftButton;
    private Header1 titleView;
    private Canvas rightBarItem;

    public NavigationButton getLeftButton() {
        return leftButton;
    }

    public void setLeftButton(NavigationButton leftButton) { 
        this.leftButton = leftButton;
        if (leftButton != null) {
            leftButton.setClassName("sc-toolbar-left");
        }
    }

    public final Header1 getTitleView() {
        return titleView;
    }

    public void setTitleView(Header1 titleView) {
        this.titleView = titleView;
        if (titleView != null) {
            titleView.setClassName("sc-toolbar-center");
        }
    }

    public final Canvas getRightBarItem() {
        return rightBarItem;
    }

    public <T extends Canvas & NavigationBarItem> void setRightBarItem(T rightBarItem) {
        this.rightBarItem = rightBarItem;
        if (rightBarItem != null) {
            rightBarItem.setClassName("sc-toolbar-right");
        }
    }
}
