package com.smartgwt.mobile.client.internal.widgets.menu;

import java.util.List;

import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Element;
import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.theme.ThemeResources;
import com.smartgwt.mobile.client.widgets.Canvas;
import com.smartgwt.mobile.client.widgets.menu.Menu;
import com.smartgwt.mobile.client.widgets.menu.MenuItem;

@SGWTInternal
public abstract class MenuImpl {

    public Element createElement() {
        final Element ret = Document.get().createDivElement();
        ret.setClassName(ThemeResources.INSTANCE.menuCSS().menuClass());
        return ret;
    }

    public abstract void init(Menu self);

    public abstract void destroyImpl(Menu self);

    public abstract void setItems(Menu self, List<? extends MenuItem> items);

    public abstract void showAt(Menu self, Canvas target, int x, int y, int minX, int maxX, int minY, int maxY);

    public abstract void hide(Menu self);
}
