/*
 * SmartGWT Mobile
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * SmartGWT Mobile is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  SmartGWT Mobile is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */

package com.smartgwt.mobile.client.theme;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.TextResource;
import com.smartgwt.mobile.client.internal.theme.ThemeResourcesFactory;

/**
 * ClientBundle that makes CSS accessible as TextResource. Not using CssResources due to GWT's inability to parse advanced CSS that
 * has browser extensions or CSS3 syntax.
 */
public interface ThemeResources extends ClientBundle {
    public static final ThemeResources INSTANCE = GWT.<ThemeResourcesFactory>create(ThemeResourcesFactory.class).create();

    @Source("iOS/activity-indicator.css")
    public TextResource activityIndicatorCSS();

    @Source("iOS/activity-indicator-android.css")
    public TextResource activityIndicatorCSSAndroid();

    @Source("iOS/alertview.css")
    public TextResource alertviewCSS();

    @Source("iOS/base.css")
    public TextResource baseCSS();

    @Source("iOS/buttons.css")
    public TextResource buttonsCSS();

    @Source("iOS/form.gwt.css")
    public FormCssResource formCSS();

    @Source("iOS/dialog.css")
    public TextResource dialogCSS();

    @Source("iOS/layout.css")
    public TextResource layoutCSS();

    @Source("iOS/navigationbar.css")
    public TextResource navigationBarCSS();

    @Source("iOS/panel.css")
    public TextResource panelCSS();

    @Source("iOS/picker.css")
    public TextResource pickerCSS();

    @Source("iOS/popover.css")
    public TextResource popoverCSS();

    @Source("iOS/progressbar.css")
    public TextResource progressbarCSS();

    @Source("iOS/scrollable.css")
    public TextResource scrollableCSS();

    @Source("iOS/slider.css")
    public TextResource sliderCSS();

    @Source("iOS/switchitem.css")
    public TextResource switchItemCSS();

    @Source("iOS/tableview.css")
    public TextResource tableViewCSS();

    @Source("iOS/tabs.css")
    public TextResource tabsCSS();

    @Source("iOS/toolbar.css")
    public TextResource toolbarCSS();

    @Source("iOS/menu.gwt.css")
    public MenuCssResource menuCSS();
}
