/*
 * SmartGWT Mobile
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * SmartGWT Mobile is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  SmartGWT Mobile is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */

package com.smartgwt.mobile.client.types;

/**
 * Enum with constants for various icon alignment options.
 *
 * @see com.smartgwt.mobile.client.widgets.BaseButton#setIconAlign(IconAlign)
 */
public enum IconAlign {
    LEFT("icon-align-left"),
    RIGHT("icon-align-right"),
    TOP("icon-align-top"),
    BOTTOM("icon-align-bottom");

    private String value;
    
    IconAlign(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }
}
