package com.smartgwt.mobile.client.util;

import java.util.Date;

import com.google.gwt.i18n.client.DefaultDateTimeFormatInfo;

public class DateUtil {
    static DateDisplayFormatter normalDateDisplayFormatter;
    static DateDisplayFormatter normalTimeDisplayFormatter;
    static DateDisplayFormatter shortDateDisplayFormatter;
    static DateDisplayFormatter shortDateTimeDisplayFormatter;
    static DefaultDateTimeFormatInfo defaultDateTimeFormatInfo;

    private DateUtil(){}
    
    static void setNormalDateDisplayFormatter(DateDisplayFormatter formatter) {
        normalDateDisplayFormatter = formatter;
    }
    
    static void setShortDateDisplayFormatter(DateDisplayFormatter formatter) {
        shortDateDisplayFormatter = formatter;
    }
    
    static void setShortDatetimeDisplayFormatter(DateDisplayFormatter formatter) {
        shortDateTimeDisplayFormatter = formatter;
    }
    
    static void setNormalTimeDisplayFormatter(DateDisplayFormatter formatter) {
        normalTimeDisplayFormatter = formatter;
    }

    static String format(Date date) {
        if(normalDateDisplayFormatter != null) {
            return normalDateDisplayFormatter.format(date);
        }
        return null;
    }
    
    static String formatAsShortDate(Date date) {
        if(shortDateDisplayFormatter != null) {
            return shortDateDisplayFormatter.format(date);
        }
        return null;
    }
    
    static String formatAsShortDatetime(Date date) {
        if(shortDateTimeDisplayFormatter != null) {
            return shortDateTimeDisplayFormatter.format(date);
        }
        return null;
    }
}
