package com.smartgwt.mobile.client.widgets;

public abstract class Action {
	private String title;
	private String icon;
	private int iconSize;
	private String tooltip;
	
	public Action(String title) {
		this.title = title;
	}
	
	public Action(String title, String icon, int iconSize) {
		this.title = title;
		this.icon = icon;
		this.iconSize = iconSize;
	}
	
	public Action(String title, String icon, int iconSize, String tooltip) {
		this.title = title;
		this.icon = icon;
		this.iconSize = iconSize;
		this.tooltip = tooltip;
	}

	public String getTitle() {
		return title;
	}

	public String getIcon() {
		return icon;
	}

	public String getTooltip() {
		return tooltip;
	}

	public int getIconSize() {
		return iconSize;
	}
	
	abstract public void execute(ActionContext context);
		
}
