package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.InputElement;
import com.google.gwt.user.client.Event;
import com.smartgwt.mobile.client.internal.util.ElementUtil;
import com.smartgwt.mobile.client.widgets.BaseButton.ButtonType;

public class ButtonItem extends FormItem {

    public ButtonItem(String name, String title) {
        super(name,  Document.get().createButtonInputElement());
        setTitle(title);
        setClassName("sc-button");
        setClassName(ButtonType.BORDERED.getValue());

        sinkEvents(Event.ONCLICK);
    }

    public ButtonItem(String name, String title, String value) {
        this(name, title);
        setValue(value);
    }

    @Override
    public void onBrowserEvent(Event event) {
        super.onBrowserEvent(event);
        if (isEnabled() && event.getTypeInt() == Event.ONCLICK) {
            final Element activeElement = ElementUtil.getActiveElement();
            if (activeElement != null) activeElement.blur();
        }
    }

    @Override
    protected void onStart(Event event) {
        super.onStart(event);
        InputElement input = getElement().cast();
        _value = input.getValue();
        input.addClassName("touched");
    }

    @Override
    protected void onEnd(Event event) {
        getElement().removeClassName("touched");
        super.onEnd(event);
    }

    @Override
    void _setElementValue(Object displayValue, Object newValue) {
        InputElement input = getElement().cast();
        String str;
        if (displayValue instanceof String) str = (String)displayValue;
        else str = displayValue == null ? "" : displayValue.toString();
        input.setValue(str);
    }

    @Override
    public boolean validate() {
        return _value instanceof String;
    }
}
