package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.regexp.shared.RegExp;

public class EmailItem extends TextItem {

	public EmailItem(String name) {
		super(name);
        String pattern = "^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+$";
	    regExp = RegExp.compile(pattern);
        getElement().setAttribute("type", "email");
        getElement().setAttribute("pattern", pattern);
	}

	public EmailItem(String name, String title) {
		this(name);
        setTitle(title);
	}

    public EmailItem(String name, String title, String placeholder) {
        this(name);
        setTitle(title);
        setPlaceholder(placeholder);
    }

    @Override
    public boolean validate() {
		return regExp.test((String)getValue());
	}
}
