package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.regexp.shared.RegExp;

public class PhoneItem extends TextItem {

	public PhoneItem(String name) {
		super(name);
        String pattern = "^(\\+\\d)*\\s*(\\(\\d{3}\\)\\s*)*\\d{3}(-{0,1}|\\s{0,1})\\d{2}(-{0,1}|\\s{0,1})\\d{2}$";
	    regExp = RegExp.compile(pattern);
        getElement().setAttribute("type", "tel");
        getElement().setAttribute("pattern", pattern);
	}

	public PhoneItem(String name, String title) {
		this(name);
        setTitle(title);
	}

    public PhoneItem(String name, String title, String placeholder) {
        this(name, title);
        setPlaceholder(placeholder);
	}

    @Override
    public boolean validate() {
		return regExp.test(getValue().toString());
	}
}
