package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Style;
import com.smartgwt.mobile.client.theme.FormCssResource;
import com.smartgwt.mobile.client.theme.ThemeResources;

public class SpacerItem extends FormItem {

    private static final FormCssResource CSS = ThemeResources.INSTANCE.formCSS();
    private static final int DEFAULT_HEIGHT = 15;
    private static int nextNum = 1;
    static {
        CSS.ensureInjected();
    }

    public SpacerItem() {
        super("$36z-" + Integer.toString(nextNum++), Document.get().createDivElement());
        getElement().addClassName(CSS.spacerItemClass());
        setHeight(DEFAULT_HEIGHT);
        getElement().getStyle().setHeight(DEFAULT_HEIGHT, Style.Unit.PX);
    }

    @Override
    public void setHeight(int height) {
        int newHeight = height;
        if (newHeight < 0) newHeight = 0;
        super.setHeight(newHeight);
        getElement().getStyle().setHeight(newHeight, Style.Unit.PX);
    }

    @Override
    public boolean validate() {
        return true;
    }
}
