package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.InputElement;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.regexp.shared.RegExp;
import com.smartgwt.mobile.client.internal.widgets.form.fields.events.InputHandler;

public class TextItem extends FormItem {

    private HandlerRegistration inputRegistration;
    RegExp regExp;
    String inputType = "text";

    public TextItem(String name) {
        super(name, Document.get().createTextInputElement());
        init();
    }

    public TextItem(String name, String title) {
        this(name);
        setTitle(title);
    }

    public TextItem(String name, String title, String placeholder) {
        this(name, title);
        setPlaceholder(placeholder);
    }

    private void init() {
        if (_changeOnKeypress) {
            assert inputRegistration == null;
            inputRegistration = _addInputHandler(getElement(), new InputHandler() {

                @Override
                public void _onInput() {
                    _handleInput();
                }
            });
        }
    }

    @Override
    public void destroy() {
        inputRegistration.removeHandler();
        super.destroy();
    }

    @Override
    public void setCanEdit(Boolean canEdit) {
        super.setCanEdit(canEdit);
        getElement().<InputElement>cast().setReadOnly(!getCanEdit());
    }

    public String getValueAsString() {
        Object value = super.getValue();
        if (value == null) return "";
        else return value.toString();
    }

    @Override
    public boolean validate() {
        return getValue() instanceof String;
    }
}
