package com.smartgwt.mobile.client.widgets.form.fields;

import com.google.gwt.regexp.shared.RegExp;

public class UrlItem extends TextItem {

	public UrlItem(String name) {
		super(name);
        String pattern = "^[A-Za-z]+://[A-Za-z0-9-_]+\\.[A-Za-z0-9-_%&\\?\\/.=]+$";
	    regExp = RegExp.compile(pattern);
        getElement().setAttribute("type", "url");	
        getElement().setAttribute("pattern", pattern);
	}

	public UrlItem(String name, String title) {
		this(name);
        setTitle(title);
	}

    @Override
    public boolean validate() {
        return regExp.test(getValueAsString());
    }
}
