package com.smartgwt.mobile.client.widgets.grid;

import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.client.data.Record;

public class ListGridField {

    private String name;
    private boolean escapeHTML = false;
    private CellFormatter formatter = null;
    private GroupTitleRenderer groupTitleRenderer;
    private GroupValueFunction groupValueFunction;

    public ListGridField(String name) {
        this.name = name;
    }

    public final String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public final boolean getEscapeHTML() {
        return escapeHTML;
    }

    public void setEscapeHTML(Boolean escapeHTML) {
        this.escapeHTML = escapeHTML == null ? false : escapeHTML.booleanValue();
    }

    public void setCellFormatter(CellFormatter formatter) {
        this.formatter = formatter;
    }

    public final GroupTitleRenderer getGroupTitleRenderer() {
        return groupTitleRenderer;
    }

    public void setGroupTitleRenderer(GroupTitleRenderer groupTitleRenderer) {
        this.groupTitleRenderer = groupTitleRenderer;
    }

    public final GroupValueFunction getGroupValueFunction() {
        return groupValueFunction;
    }

    public void setGroupValueFunction(GroupValueFunction groupValueFunction) {
        this.groupValueFunction = groupValueFunction;
    }

    @SGWTInternal
    public String _formatCellValue(Object value, Record record, int rowNum, int fieldNum, ListGrid grid) {
        if (formatter != null) return formatter.format(value, record, rowNum, fieldNum);

        final String fieldName = grid.getFieldName(fieldNum);
        if (fieldName == null) return null;
        return record.getAttribute(fieldName);
    }
}
