package com.smartgwt.mobile.internal.gwt.dom.client;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.NodeList;
import com.google.gwt.event.shared.HandlerRegistration;
import com.smartgwt.mobile.SGWTInternal;
import com.smartgwt.mobile.internal.gwt.dom.client.event.AnimationEndHandler;
import com.smartgwt.mobile.internal.gwt.dom.client.event.TransitionEndHandler;

@SGWTInternal
public class SuperElement extends Element {

    private static native JavaScriptObject createAnimationEndListener(AnimationEndHandler handler) /*-{
        return $entry(function (event) {
            handler.@com.smartgwt.mobile.internal.gwt.dom.client.event.AnimationEndHandler::onAnimationEnd(Lcom/smartgwt/mobile/internal/gwt/dom/client/event/AnimationEndEvent;)(event);
        });
    }-*/;

    private static native JavaScriptObject createTransitionEndListener(TransitionEndHandler handler) /*-{
        return $entry(function (event) {
            handler.@com.smartgwt.mobile.internal.gwt.dom.client.event.TransitionEndHandler::onTransitionEnd(Lcom/smartgwt/mobile/internal/gwt/dom/client/event/TransitionEndEvent;)(event);
        });
    }-*/;

    protected SuperElement() {}

    public final native HandlerRegistration addEventListener(String type, JavaScriptObject listener, boolean useCapture) /*-{
        this.addEventListener(type, listener, useCapture);
        return @com.smartgwt.mobile.client.internal.widgets.events.NativeHandlerRegistration::new(Lcom/google/gwt/dom/client/Element;Ljava/lang/String;Lcom/google/gwt/core/client/JavaScriptObject;Z)(this, type, listener, useCapture);
    }-*/;

    public final HandlerRegistration addAnimationEndHandler(AnimationEndHandler handler) {
        return addEventListener(DOMConstants.INSTANCE.getAnimationEndEventType(), createAnimationEndListener(handler), false);
    }

    public final HandlerRegistration addTransitionEndHandler(TransitionEndHandler handler) {
        return addEventListener(DOMConstants.INSTANCE.getTransitionEndEventType(), createTransitionEndListener(handler), false);
    }

    /**
     * Returns a non-live NodeList of all elements descended from the current element which match
     * the specified CSS selectors.
     */
    public final native NodeList<Element> querySelectorAll(String selectors) /*-{
        return this.querySelectorAll(selectors);
    }-*/;
}
